/*
** DINA log parser daemon.
**
** Copyright (c) Lev Walkin, 2000
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <syslog.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <unistd.h>
#include <err.h>
#include <errno.h>

#include <cost.h>
#include <strfunc.h>
#include <lgba.h>

#include "dina.lpd.h"

#ifdef	USE_DESIRE_ACCOUNTING

#include <desire.h>
ctb_data	data;

#endif

int
account(AcctInfo *ai) {
	int les;
	char *username;
	char *s;
	int cost;
	char buf[64];

	username=strndup(ai->username, DI_USERNAME);
	s=username;
	while(*s) *s++=tolower(*s);

	if(maintain) {
		if(ai->ss)
			les=nas_line_set_connected(ai->nas_id, ai->line,
				username, ai->session_id);
		else
			les=nas_line_set_disconnected(ai->nas_id, ai->line,
				ai->session_id);

		if(les)
			syslog(LOG_WARNING, "Can't maintain line %s@%d@%s: %d",
				username, ai->line, ai->nas_id, les);
	};

	if(ai->ss != 0)
		return 0;

	if((les=load(username))) {
		syslog(LOG_ERR, "Error loading '%s': %s.\n",
			username, lgba_err2string(les));
		return les;
	};

	cost=(int)lc_timecost(ai->timestamp - ai->session_time,
		ai->session_time,
		"online", getattr2("objectclass"));

#ifdef EXTERN
	sprintf(mybuf, EXTERN, user, (int)cost);
	system(mybuf);
#endif

	syslog(LOG_INFO, "Decreasing resource for %s: spent %d, cost %d, left: %d.", username, ai->session_time, cost, atoi(getattr(resleft)) - cost);

	if(cost) sprintf(buf, "%+d", -cost);
	else sprintf(buf, "=%d", atoi(getattr(resleft)));

	setattr(resleft, buf);

	lgba_saveloaded(0);


#ifdef	USE_DESIRE_ACCOUNTING

	if(!acctservice || !*acctservice) return 0;

	data.TS=ai->timestamp;
	data.FL.s.s1=0;
	data.FL.s.s2=ai->line;
	data.In=ai->obytes;
	data.Out=ai->ibytes;
	(int)data.Src=cost;
	(int)data.Dst=atoi(getattr(resleft));
	data.U1=atoi(getattr("uidnumber"));
	data.U2=ai->session_time;

	if(ctb_chname(username))
		syslog(LOG_ERR, "Can't change name to '%s'", username);
	else if(ctb_add(&data))
		syslog(LOG_ERR, "Can't append DESIRE log for '%s'", username);

	ctb_chname("");	/* close opened in ctb_add() file descriptor */

#endif

	return 0;
};

