/*
** DINA TACACS+ log parser daemon.
**
** Based on accter (c) Lev Walkin, 1998, 1999, 2000
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <syslog.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <unistd.h>
#include <err.h>

#include <lgba.h>
#include <strfunc.h>
#include <cost.h>

#include "../dina.lpd.common/dina.lpd.h"

AcctInfo ai;

int
parse(char *str) {
	static slist *sl=NULL;
	static slist *at=NULL;
	static slist *va=NULL;
	char **vp;
	char *p;

	if(sl) {
		sclear(sl); sclear(at); sclear(va);
	} else {
		sl=sinit(NULL); at=sinit(NULL); va=sinit(NULL);
	};

	split(sl, str);
	if(sl->count < 8)
		return 0;

	vp=sarray(sl, 8) - 1;
	while(*(++vp)) {
		if((p=strchr(*vp, '='))) *p++=0;
		else p="";
		sadd(at, *vp);
		sadd(va, p);
	};

#	define TME	(sl->list[2])
#	define NAS	(sl->list[3])
#	define USER	(sl->list[4])
#	define LINE	(sl->list[5])
#	define SUS	(sl->list[7])	/* start, update, stop... */

	memset(&ai, 0, sizeof(ai));
	ai.timestamp = atoi(TME);
	strncpy(ai.username, USER, DI_USERNAME);
	strncpy(ai.nas_id, NAS, DI_NAS_ID);
	ai.line = atoi(LINE + strcspn(LINE, "0123456789"));
	ai.ss = eq(SUS, "stop")?0:1;

	if((p=sget2(at, "elapsed_time", va)))
		ai.session_time = atoi(p);

	if((p=sget2(at, "bytes_in", va)))
		ai.obytes = atoi(p);

	if((p=sget2(at, "bytes_out", va)))
		ai.ibytes = atoi(p);

	account(&ai);

	return 0;
};

