#ifndef	__INTERN_H__
#define	__INTERN_H__

#include "libdina.h"
#include <sys/types.h>

#define	SHMEM_KEY	131322
#define	SHSEM_KEY	131323
#define	SHMSG_KEY	131324
#define	SHSEM_ITEMS	16
#define	SHMEM_SIZE	8192

/*
** DINA Shared memory usage:
**
** [DINA_MemoryHeader] [LineEntry] [LineEntry] ...
**
*/

#define	DINA_IPC_VERSION	1

typedef struct {
	time_t	created;	/* Shared memory creation time */
	short	version;	/* DINA IPC version */
	short	lines;		/* Overall quantity of lines => memory usage */
	size_t	transitions;	/* Number of line transitions */
	size_t	memsize;	/* Shared memory segment size */
	size_t  empty1;
	size_t  empty2;
	size_t  empty3;
	size_t  empty4;
} DINA_MemoryHeader;


extern int _libdina_initialized;
extern DINA_MemoryHeader *_libdina_mheader;
extern LineEntry *_libdina_lines;
extern int _libdina_sem;
extern int _libdina_msqid;
int _libdina_init();
int _libdina_init_memory();
void _libdina_cleanup();

int
_libdina_lock();

int
_libdina_unlock();

#endif
