#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <time.h>

#include <libdina.h>
#include "intern.h"

int
iterate_through_lines(char *optUser, char *optNas, int optLine,
	int (*optCount)(int Count), int (*optIterateFunc)(int n, LineEntry *le))
{

	LineEntry *iter;
	int n;
	int Count;
	int Iterate;

	if(_libdina_init())
		return -1;

	if(optUser && strlen(optUser) > DI_USERNAME)
		return -2;
	if(optNas && strlen(optNas) > DI_NAS_ID)
		return -2;
	if(optLine < -1)
		return -2;

	/* Lock the shared memory */
	if(_libdina_lock() == -1)
		return -1;

	/*********** MEMORY LOCKED ****************/

	Iterate =  _libdina_mheader->lines;

	/* Count support */
	if(optCount || !optIterateFunc) {
		Count = 0;
		for(n = _libdina_mheader->lines,
			iter = _libdina_lines; n--; iter++) {
			/* Checking the line number first */
			if((optLine >= 0)
				&& (iter->LineNumber != optLine))
					continue;
			if(optUser
				&& strncasecmp(iter->UserName, optUser, DI_USERNAME))
					continue;
			if(optNas
				&& strncasecmp(iter->NAS, optNas, DI_NAS_ID))
					continue;
			/* Line found! */
			Count++;
		};
		if(optCount) {
			n = optCount(Count);
			if(n <= 0) {
				_libdina_unlock();
				return n<0?0:n;
			};
			if(Count > n) Iterate = n;
		};
	};

	if(optIterateFunc) {
		char le[sizeof(LineEntry)+1];

		/* Clear the last byte */
		le[sizeof(LineEntry)] = '\0';

		Count = 0;
		/* Iterate function support */
		for(n = _libdina_mheader->lines,
			iter = _libdina_lines; n--; iter++) {
			/* Checking the line number first */
			if((optLine >= 0)
				&& (iter->LineNumber != optLine))
					continue;
			if(optUser
				&& strncasecmp(iter->UserName, optUser, DI_USERNAME))
					continue;
			if(optNas
				&& strncasecmp(iter->NAS, optNas, DI_NAS_ID))
					continue;

			/* Line found! */
			Count++;

			/* For better protection */
			memcpy(le, iter, sizeof(LineEntry));
			if(optIterateFunc(Count, (LineEntry *)le) != 0)
				break;
			if(Count > Iterate) {
				Count = Iterate;
				break;
			};
		};

	};

	/********** MEMORY UNLOCKED ****************/

	/* Unlock the shared memory */
	_libdina_unlock();
	return Count;
};



